<script setup lang="ts">
import { ref } from 'vue'

import type { VForm } from 'vuetify/components'


import AddStock from './AddStockDetail.vue'

import { useStockStore } from '../../stores/stock'
import { useUserStore } from '@/stores/user';
import { useStockDetailStore } from '@/stores/stockDetail';
import { useMaterialStore } from '@/stores/material';
import { useBranchStore } from '@/stores/branch';
import type { Stock } from '@/types/Stock';
import type { Material } from '@/types/Material';
import type { StockDetail } from '@/types/StockDetail';


const userStore = useUserStore()
const stockDetailStore = useStockDetailStore()
const materialStore = useMaterialStore()
const branchStore = useBranchStore()
const stockStore = useStockStore()
const form = ref(true)
const refForm = ref<VForm | null>(null)

async function save() {
  for (const material of materialStore.addsomeMaterial) {
    const existingMaterial = materialStore.materials.find(
      (mat: any) => mat.name.trim().toLowerCase() === material.name.trim().toLowerCase()
    )
    if (existingMaterial) {
      // Update existing material in materials array
      Object.assign(existingMaterial, material)
    } else {
      // Add new material from addsomeMaterial to materials array
      materialStore.materials.push(material)
    }
  }
  console.log('materials: ', materialStore.materials)
  for (const mat of materialStore.materials) {
    console.log('mat: ', mat)
    materialStore.saveMaterial(mat)
  }
  materialStore.getMaterials()
  materialStore.getMaterialsInNewAtt()

  const stock = ref<Stock>(stockStore.editedStock)
  //tran material to stockdetail
  const newMaterials: Material[] = materialStore.materials

  const stockDetails: StockDetail[] = []

  for (const mat of newMaterials) {
    const newStockDetail: StockDetail = {
      id: -1,
      QOH: mat.amount,
      materialId: mat.id,
      balance: mat.amount - mat.minimum,
      StockId: -1
    }

    stockDetails.push(newStockDetail)
  }

  try {
    stock.value = {
      id: -1,
      date: stockStore.formatDate(new Date()),
      stockDetails: stockDetails,
      branchID: userStore.currentUser?.branch.id,
      userID: userStore.currentUser?.id
    }
  } catch (error) {
    console.error('cant craeet stock at add stock some')
  }
  stockStore.saveStock(stock.value)
  console.log('stock while saving: ', stock.value)
  stockStore.closeDialog()
}
</script>

<template>
  <v-dialog v-model="stockStore.addAllDialog" persistent width="1440" height="810">
    <v-card>
      <v-card-title>
        <span class="text-h5">ADD Stock</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="form">
          <v-container>
            <v-sheet :height="500" :width="1050" class="ma-6 pa-6"
              :style="{ boxShadow: 'inset 0px 0px 10px 3px rgba(0, 0, 0, 0.5)' }">
              <AddStock v-if="stockStore.addAllDialog"></AddStock>
            </v-sheet>
          </v-container>
        </v-form>
      </v-card-text>

      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn variant="text" @click="stockStore.closeDialog()">
          Close
        </v-btn>
        <v-btn variant="text" @click="save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}

.custom-header {
  background-color: #ffcb5e;
}
</style>
